import { CommonProps } from '@/common/types/props';
import { ContextMenuItem, ContextMenuItems } from './types';
export interface Props extends CommonProps {
    items: ContextMenuItems | undefined;
    appendTo?: string | HTMLElement;
    left?: number;
    top?: number;
    showOnMount?: boolean;
    onLeftSide?: boolean;
}
declare const _default: import("vue").DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    appendTo: string;
    left: number;
    top: number;
    showOnMount: boolean;
    onLeftSide: boolean;
}>, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    mount: () => void;
    unmount: () => void;
    click: (event: MouseEvent) => void;
    closeContextMenu: () => void;
    contextItemClick: (item: ContextMenuItem) => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    appendTo: string;
    left: number;
    top: number;
    showOnMount: boolean;
    onLeftSide: boolean;
}>>> & {
    onClick?: ((event: MouseEvent) => any) | undefined;
    onMount?: (() => any) | undefined;
    onUnmount?: (() => any) | undefined;
    onCloseContextMenu?: (() => any) | undefined;
    onContextItemClick?: ((item: ContextMenuItem) => any) | undefined;
}, {
    appendTo: string | HTMLElement;
    left: number;
    top: number;
    showOnMount: boolean;
    onLeftSide: boolean;
}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
